
Ruby - Bug #11989

Dedenting interpolating heredoc can interpret escapes incorrectly

01/14/2016 12:45 PM - whitequark (whitequark *)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.0p0 (2015-12-25 revision

53290) [x86_64-linux]

Backport: 2.0.0: DONTNEED, 2.1: DONTNEED,

2.2: DONTNEED, 2.3: DONE

Description

It is clear that the dedenting <<~HEREDOC feature was intended to only consider actual whitespace in the source file as indentation,

not any escaped whitespace. E.g.:

p <<~"E"

  \ x

   y

E

 It prints " x\n y\n". So "\ " does not count as whitespace. There is even an MRI test for this.

However, this case is handled differently:

p <<~"E"

  x\n   y

E

 It prints "x\n y\n". So "\n" is counted as whitespace, like an actual newline would be. I think it should print "x\n   y\n".

Related issues:

Related to Ruby - Bug #14584: Squigly heredoc with interpolation that has a s... Closed

Associated revisions

Revision 45acdf4df45577ba1039f97990edaa1dcc8c8b96 - 01/18/2016 05:37 AM - nobu (Nobuyoshi Nakada)

parse.y: escaped newline in dedenting heredoc

parse.y (parser_here_document): an escaped newline is not an

actual newline, and the rest part should not be dedented.

[ruby-core:72855] [Bug #11989]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@53573 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 45acdf4d - 01/18/2016 05:37 AM - nobu (Nobuyoshi Nakada)

parse.y: escaped newline in dedenting heredoc

parse.y (parser_here_document): an escaped newline is not an

actual newline, and the rest part should not be dedented.

[ruby-core:72855] [Bug #11989]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@53573 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 091f98cf8c34c4288d0a3afcddd566ab652a30fb - 03/18/2018 03:29 PM - U.Nakamura 

merge revision(s) 53573: [Backport #11989]

* parse.y (parser_here_document): an escaped newline is not an

actual newline, and the rest part should not be dedented.

[ruby-core:72855] [Bug #11989]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@62826 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 091f98cf - 03/18/2018 03:29 PM - U.Nakamura 

merge revision(s) 53573: [Backport #11989]

* parse.y (parser_here_document): an escaped newline is not an
actual newline, and the rest part should not be dedented.

[ruby-core:72855] [Bug #11989]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@62826 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/14/2016 12:49 PM - whitequark (whitequark *)

- Description updated

#2 - 01/18/2016 05:37 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r53573.

parse.y: escaped newline in dedenting heredoc

parse.y (parser_here_document): an escaped newline is not an

actual newline, and the rest part should not be dedented.

[ruby-core:72855] [Bug #11989]

#3 - 03/11/2018 12:00 PM - nobu (Nobuyoshi Nakada)

- Description updated

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.0.0: DONTNEED, 2.1: DONTNEED, 2.2:

DONTNEED, 2.3: REQUIRED

#4 - 03/11/2018 12:00 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #14584: Squigly heredoc with interpolation that has a string literal withe spaces gets incorrect value added

#5 - 03/18/2018 03:29 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: DONTNEED, 2.1: DONTNEED, 2.2: DONTNEED, 2.3: REQUIRED to 2.0.0: DONTNEED, 2.1: DONTNEED, 2.2:

DONTNEED, 2.3: DONE

ruby_2_3 r62826 merged revision(s) 53573.
